<?php
include_once(dirname(__FILE__).'/../../../../../../bootstrap.php');

class PapayaUiControlCommandToolbarTest extends PapayaTestCase {

  /**
  * @covers PapayaUiControlCommandToolbar
  */
  public function testConstructor() {
    $command = new PapayaUiControlCommandToolbar_TestProxy(
      $toolbar = $this->getMock('PapayaUiToolbar')
    );
    $this->assertSame($toolbar, $command->toolbar());
  }

  /**
  * @covers PapayaUiControlCommandToolbar
  */
  public function testGetAfterSet() {
    $command = new PapayaUiControlCommandToolbar_TestProxy(
      $this->getMock('PapayaUiToolbar')
    );
    $command->toolbar($toolbar = $this->getMock('PapayaUiToolbar'));
    $this->assertSame($toolbar, $command->toolbar());
  }

  /**
  * @covers PapayaUiControlCommandToolbar
  */
  public function testAppendTo() {
    $elements = $this->getMock('PapayaUiToolbarElements');
    $elements
      ->expects($this->once())
      ->method('add')
      ->with($this->isInstanceOf('PapayaUiToolbarElement'));

    $toolbar = $this->getMock('PapayaUiToolbar');
    $toolbar
      ->expects($this->any())
      ->method('elements')
      ->will($this->returnValue($elements));

    $dom = new PapayaXmlDocument();
    $dom->appendElement('test');
    $command = new PapayaUiControlCommandToolbar_TestProxy($toolbar);
    $command->testCase = $this;
    $command->appendTo($dom->documentElement);
    $this->assertEquals('<test/>', $dom->documentElement->saveXml());
  }

}

class PapayaUiControlCommandToolbar_TestProxy extends PapayaUiControlCommandToolbar {

  public $testCase = NULL;

  public function appendToolbarElements() {
    $this->toolbar()->elements()->add($this->testCase->getMock('PapayaUiToolbarElement'));
  }
}